/* GCC */
#include <set>
#include <stack>
#include <queue>
#include <math.h>
#include <vector>
#include <iostream>
#include <algorithm>
#include <sstream>

#define Ri(a) scanf("%d", &(a))
#define Ri2(a,b) scanf("%d%d", &(a), &(b))
#define Wi(a) printf("%d ", (a))
#define Wi2(a,b) printf("%d %d ", (a), (b))
#define Wie(a) printf("%d\n", (a))
#define Wie2(a,b) printf("%d %d\n", (a), (b))
#define FOR(i,a,b) for( int i = (a), _n_ = (b); i <= _n_; i++ )
#define FORD(i,a,b) for( int i = (a), _n_ = (b); i >= _n_; i-- )
#define forn(i,n) FOR((i),0,(n)-1)
#define F first
#define S second
#define pb push_back
#define mp make_pair
#define pause system("pause")
#define INF 1000000000

using namespace std;

struct edge {
       int x, t, w;
       
       edge(){}
       edge( int x, int t, int w ): x(x), t(t), w(w) {}
};

bool operator< ( const edge& a, const edge& b ) {
     return a.w < b.w;
}

char c[31250];

int ans1t = -1, ans1w, ans2t = -1, ans2w = INF;

int n, m, tb, b, e, _prew_[250], _now_[250], *prew = _prew_, *now = _now_, d[250][1441];
vector <edge> gr[250][1441];

set < edge > s;

int main() {
    freopen("tax.in", "r", stdin);
    freopen("tax.out", "w", stdout);
    
    Ri2(n, m);
    Ri( tb );
    Ri2( b, e );
    b--;
    e--;
    
    {
        int v, tp, w, vn, tpn, wn;
        forn( i, m ) {
              gets( c );
              istringstream iss(c);
          
              iss >> v >> tp >> w;
              v--;
              while( iss >> vn ) {
                     vn--;
                     iss >> tpn >> wn;
                     gr[v][tp].pb( edge(vn, tpn, wn) );
                     v = vn;
                     tp = tpn;
                     w = wn;
              }
          }
    }
    
    forn( i, n ) {
          forn( j, 1440 ) {
                gr[i][j].pb( edge( i, j + 1, 0 ) );
                d[i][j] = INF;
          }
          d[i][1440] = INF;
    }
    
    d[b][tb] = 0;
    s.insert( edge( b, tb, 0 ) );
    
    edge v;
    while( !s.empty() ) {
           v = *s.begin();
           s.erase( s.begin() );
           forn( i, gr[v.x][v.t].size() ) {
                 edge vn = gr[v.x][v.t][i];
                 if( d[vn.x][vn.t] > v.w + vn.w ) {
                     edge ins = edge( vn.x, vn.t, d[vn.x][vn.t] );
                     if( s.find( ins ) != s.end() ) {
                         s.erase( s.find( ins ) );
                     }
                     d[vn.x][vn.t] = v.w + vn.w;
                     ins.w = d[vn.x][vn.t];
                     s.insert( ins );
                 }
           }
    }
    
    forn( i, 1441 ) {
          if( d[e][i] != INF && ans1t == -1 ) ans1t = i, ans1w = d[e][i];
          if( d[e][i] < ans2w ) ans2w = d[e][i], ans2t = i;
    }
    
    forn( i, n ) {
          prew[i] = INF;
          now[i] = INF;
          forn( j, 1441 ) {
                prew[i] = min( prew[i], d[i][j] );
                now[i] = prew[i];
          }
    }
    
    int tm = 0;
    int ch = 1;
    while( ch ) {
           ch = 0;
           tm += 1440;
           forn( i, n ) {
                 d[i][0] = prew[i];
                 if( d[i][0] != INF ) {
                     s.insert( edge( i, 0, d[i][0] ) );
                 }
           }
           forn( i, n ) {
                FOR( j, 1, 1440 ) d[i][j] = INF;
           }
           
           edge v;
           while( !s.empty() ) {
                  v = *s.begin();
                  s.erase( s.begin() );
                  forn( i, gr[v.x][v.t].size() ) {
                        edge vn = gr[v.x][v.t][i];
                        if( d[vn.x][vn.t] > v.w + vn.w ) {
                            edge ins = edge( vn.x, vn.t, d[vn.x][vn.t] );
                            if( s.find( ins ) != s.end() ) {
                                s.erase( s.find( ins ) );
                            }
                            d[vn.x][vn.t] = v.w + vn.w;
                            ins.w = d[vn.x][vn.t];
                            s.insert( ins );
                        }
                  }
           }
           
           forn( i, 1441 ) {
                 if( d[e][i] != INF && ans1t == -1 ) ans1t = i + tm, ans1w = d[e][i];
                 if( d[e][i] < ans2w ) ans2w = d[e][i], ans2t = i + tm;
           }
           
           forn( i, n ) {
                 now[i] = INF;
                 forn( j, 1441 ) {
                       now[i] = min( now[i], d[i][j] );
                 }
                 if( now[i] != prew[i] ) ch = 1;
           }
           
           swap( now, prew );
    }
    
    Wie2( ans1t, ans1w );
    Wie2( ans2t, ans2w );
    
    fclose(stdin);
    fclose(stdout);
    return 0;
} 
